#include<stdio.h>
#include<stdlib.h>
#include<math.h>

//Runge-Kutta
double RK(double (*f)(double, double),double a, double b, int m, double y0){
    double h,y1,y2=y0,k1,k2,k3,k4,xn;
    h=(double)(b-a)/m;
    int i;
    xn=a;
    for(i=0;i<m;i++){
        y1=y2;
        k1=f(xn,y1);
        k2=f(xn+h/2,y1+h*k1/2);
        k3=f(xn+h/2,y1+h*k2/2);
        k4=f(xn+h,y1+h*k3);
        y2=y1+h*(k1+2*k2+2*k3+k4)/6;
        xn+=h;
    }
    return y2;
}

//Runge-Kutta
double ORK(double (*f)(double, double), double a, double b, int m, double y0, double k, double TRUE_Y){
    double ok;
    ok=log(fabs((TRUE_Y-RK(f,a,b,m,y0))/(TRUE_Y-RK(f,a,b,m*(int)(k+0.5),y0))))/log(k);
    return ok;
}

//Adams
double Adams(double (*f)(double, double), double a, double b, int m, double y00){
    double h,y0=y00,y1=y00,y2=y00,y3=y00,y4=y00,y4_,k1,k2,k3,k4,xn;
    h=(double)(b-a)/m;
    int i;
    xn=a;
    for(i=0;i<m;i++){
        y0=y1;
        y1=y2;
        y2=y3;
        y3=y4;
        if(i<3){
            k1=f(xn,y3);
            k2=f(xn+h/2,y3+h*k1/2);
            k3=f(xn+h/2,y3+h*k2/2);
            k4=f(xn+h,y3+h*k3);
            y4=y3+h*(k1+2*k2+2*k3+k4)/6;
        }
        else{
            y4_=y3+h*(55*f(xn,y3)-59*f(xn-h,y2)+37*f(xn-2*h,y1)-9*f(xn-3*h,y0))/24;
            y4=y3+h*(9*f(xn+h,y4_)+19*f(xn,y3)-5*f(xn-h,y2)+f(xn-2*h,y1))/24;
        }
        xn+=h;
    }
    return y4;
}

//Adams
double OAdams(double (*f)(double, double), double a, double b, int m, double y0, double k, double TRUE_Y){
    double ok;
    ok=log(fabs((TRUE_Y-Adams(f,a,b,m,y0))/(TRUE_Y-Adams(f,a,b,m*(int)(k+0.5),y0))))/log(k);
    return ok;
}

//f(x,y)
double f(double x, double y){
    return -x*x*y*y;
}

int main(void){
    //ȷֵ
    double TRUE_Y=3/(1+1.5*1.5*1.5);
    //Ȳ
    double k=1,h=0.1,y0=3,a=0,b=1.5;
    int l,m;
    //庯ָ
    double (*F)(double, double);
    F=f;
    //Runge-Kutta
    printf("ĽRunge-Kuttaʽף\n");
    for(l=0;l<=3;l++){
        //ȡʱ
        m=(int)((b-a)/h+0.5);
        printf("h=%.4lf, err=%.15E, ok=%.15E\n",h,TRUE_Y-RK(F,a,b,m,y0),ORK(F,a,b,m,y0,2,TRUE_Y));
        k=k*2;
        h=h/2;
    }
    //Adams
    k=1;
    h=0.1;
    printf("\nĽʽAdamsʽף\n");
    for(l=0;l<=3;l++){
        //ȡʱ
        m=(int)((b-a)/h+0.5);
        printf("h=%.4lf, err=%.15E, ok=%.15E\n",h,TRUE_Y-Adams(F,a,b,m,y0),OAdams(F,a,b,m,y0,2,TRUE_Y));
        k=k*2;
        h=h/2;
    }
    system("pause");
    return 0;
}
