(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      7938,        207]
NotebookOptionsPosition[      6810,        181]
NotebookOutlinePosition[      7166,        197]
CellTagsIndexPosition[      7123,        194]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "5", ",", "4", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3", ",", 
       RowBox[{"-", "7"}], ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "3", ",", "2", ",", "5", ",", 
       RowBox[{"-", "4"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", 
       RowBox[{"-", "7"}], ",", "5", ",", "1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", 
       RowBox[{"-", "4"}], ",", "3", ",", "8"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{"Eigenvalues", "[", "A", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{"Eigenvectors", "[", "A", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.7531988147707157`*^9, 3.753198933951847*^9}, {
  3.7532194469795856`*^9, 3.753219451036707*^9}, {3.753219566773178*^9, 
  3.753219585008422*^9}, {3.7532199929883227`*^9, 3.753220027375366*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"fbc491c6-4dd2-4194-9d96-f0bd05c96a27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"16.224161877381402`", ",", 
   RowBox[{"-", "12.760554989645307`"}], ",", "11.023392437654191`", ",", 
   "4.574951567326776`", ",", 
   RowBox[{"-", "4.0619508927170624`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7531989067176757`*^9, 3.7531989344475164`*^9}},
 CellLabel->"Out[7]=",ExpressionUUID->"5b23e5b1-f3a5-470d-9661-6ae941088218"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.6180362903669391`", ",", "0.5656980846260642`", ",", 
     "0.10204546804143569`", ",", "0.13284711011233702`", ",", "1.`"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.21526763849482508`"}], ",", 
     RowBox[{"-", "1.4266768103749392`"}], ",", "1.0632390944168866`", ",", 
     RowBox[{"-", "1.2675260993364368`"}], ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2.0833453972416165`"}], ",", "1.734941583836078`", ",", 
     RowBox[{"-", "2.7461893942073448`"}], ",", 
     RowBox[{"-", "3.1136084754713704`"}], ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.27422730301251774`"}], ",", 
     RowBox[{"-", "1.4409068043087288`"}], ",", 
     RowBox[{"-", "1.6013071811511146`"}], ",", "1.1141136984224183`", ",", 
     "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2.9629225047969716`"}], ",", "0.8545671772156965`", ",", 
     "1.423498378927625`", ",", "1.5243467446832317`", ",", "1.`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.7531989067176757`*^9, 3.753198934462478*^9}},
 CellLabel->"Out[8]=",ExpressionUUID->"5635155d-03d9-4a26-9ca2-1488dcc27917"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Normalize", "[", 
  RowBox[{"{", 
   RowBox[{
   "0.6180362903669391`", ",", "0.5656980846260642`", ",", 
    "0.10204546804143569`", ",", "0.13284711011233702`", ",", "1.`"}], "}"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Normalize", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "0.21526763849482508`"}], ",", 
    RowBox[{"-", "1.4266768103749392`"}], ",", "1.0632390944168866`", ",", 
    RowBox[{"-", "1.2675260993364368`"}], ",", "1.`"}], "}"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Normalize", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "2.0833453972416165`"}], ",", "1.734941583836078`", ",", 
    RowBox[{"-", "2.7461893942073448`"}], ",", 
    RowBox[{"-", "3.1136084754713704`"}], ",", "1.`"}], "}"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Normalize", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "0.27422730301251774`"}], ",", 
    RowBox[{"-", "1.4409068043087288`"}], ",", 
    RowBox[{"-", "1.6013071811511146`"}], ",", "1.1141136984224183`", ",", 
    "1.`"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Normalize", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "2.9629225047969716`"}], ",", "0.8545671772156965`", ",", 
    "1.423498378927625`", ",", "1.5243467446832317`", ",", "1.`"}], "}"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.7532200850431824`*^9, 3.753220158054917*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"8c0cde41-cc2c-438a-93f0-9e494d19fb1d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.46987820492251026`", ",", "0.43008671929990017`", ",", 
   "0.07758272789340422`", ",", "0.10100047942438292`", ",", 
   "0.76027607479738`"}], "}"}]], "Output",
 CellChangeTimes->{3.7532200969794693`*^9, 3.7532201598141675`*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"dd72723f-cd8b-4e58-a087-aa876d24c532"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.08924014970867727`"}], ",", 
   RowBox[{"-", "0.5914351689551256`"}], ",", "0.44077045962559935`", ",", 
   RowBox[{"-", "0.5254585392181862`"}], ",", "0.4145544139037999`"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.7532200969794693`*^9, 3.7532201598171606`*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"2b27e848-5e13-4bd8-a654-94f7fe25a584"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.4118661873476979`"}], ",", "0.34298862605866315`", ",", 
   RowBox[{"-", "0.5429068828550506`"}], ",", 
   RowBox[{"-", "0.6155436603953319`"}], ",", "0.19769462514137862`"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.7532200969794693`*^9, 3.7532201598191557`*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"13635b51-2db2-44b0-98d2-b3e5a3df41a8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.10396914312757176`"}], ",", 
   RowBox[{"-", "0.5462980677887783`"}], ",", 
   RowBox[{"-", "0.6071114498059628`"}], ",", "0.4223993938575155`", ",", 
   "0.37913490737581973`"}], "}"}]], "Output",
 CellChangeTimes->{3.7532200969794693`*^9, 3.7532201598221874`*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"c23f8f38-2a09-4626-b2bb-c9d2e0ba9abf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.768639921690101`"}], ",", "0.22169140337304005`", ",", 
   "0.3692832602720706`", ",", "0.39544529449047006`", ",", 
   "0.2594195158481779`"}], "}"}]], "Output",
 CellChangeTimes->{3.7532200969794693`*^9, 3.7532201598251796`*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"5e4864c2-1ddd-44a3-8ab2-662e18de80b2"]
}, Open  ]]
},
WindowSize->{759, 581},
WindowMargins->{{Automatic, 109}, {9, Automatic}},
FrontEndVersion->"11.3 for Microsoft Windows (64-bit) (2018\:5e743\:670828\
\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 1139, 27, 101, "Input",ExpressionUUID->"fbc491c6-4dd2-4194-9d96-f0bd05c96a27"],
Cell[1722, 51, 382, 7, 32, "Output",ExpressionUUID->"5b23e5b1-f3a5-470d-9661-6ae941088218"],
Cell[2107, 60, 1256, 30, 71, "Output",ExpressionUUID->"5635155d-03d9-4a26-9ca2-1488dcc27917"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3400, 95, 1451, 35, 290, "Input",ExpressionUUID->"8c0cde41-cc2c-438a-93f0-9e494d19fb1d"],
Cell[4854, 132, 353, 7, 32, "Output",ExpressionUUID->"dd72723f-cd8b-4e58-a087-aa876d24c532"],
Cell[5210, 141, 402, 8, 32, "Output",ExpressionUUID->"2b27e848-5e13-4bd8-a654-94f7fe25a584"],
Cell[5615, 151, 402, 8, 32, "Output",ExpressionUUID->"13635b51-2db2-44b0-98d2-b3e5a3df41a8"],
Cell[6020, 161, 403, 8, 32, "Output",ExpressionUUID->"c23f8f38-2a09-4626-b2bb-c9d2e0ba9abf"],
Cell[6426, 171, 368, 7, 64, "Output",ExpressionUUID->"5e4864c2-1ddd-44a3-8ab2-662e18de80b2"]
}, Open  ]]
}
]
*)

